/*
*		Header file for class CVME
*
*
*/

#define BT973     //dopisane
#include "C:\Program Files\Bit3\983\v2.4\INCLUDE\btapi.h"


#ifndef CVME_H
#define CVME_H

class CVME{

public:

	CVME(void);
	void Initialize(bt_dev_t);
	void Initialize(int,bt_dev_t);
	CVME::~CVME(void);
	bt_error_t Write(bt_devaddr_t, DWORD *, DWORD );
	bt_error_t Write(bt_devaddr_t, WORD *, DWORD );
	bt_error_t Write(bt_devaddr_t, BYTE *, DWORD );
	bt_error_t Write(bt_devaddr_t, DWORD);
	bt_error_t Write(bt_devaddr_t, WORD);
	bt_error_t Write(bt_devaddr_t, BYTE);
	bt_error_t Write(bt_devaddr_t, DWORD * , DWORD numOfBytes, DWORD blockSizeInBytes);
	bt_error_t Write(bt_devaddr_t, WORD * , DWORD numOfBytes, DWORD blockSizeInBytes);
	bt_error_t Write(bt_devaddr_t, BYTE * , DWORD numOfBytes, DWORD blockSizeInBytes);

	bt_error_t Read(bt_devaddr_t, DWORD *, DWORD );
	bt_error_t Read(bt_devaddr_t, WORD *, DWORD );
	bt_error_t Read(bt_devaddr_t, BYTE *, DWORD );
	bt_error_t Read(bt_devaddr_t, DWORD *);
	bt_error_t Read(bt_devaddr_t, WORD * );
	bt_error_t Read(bt_devaddr_t, BYTE *);
	bt_error_t Read(bt_devaddr_t, BYTE *, DWORD numOfBytes, DWORD blockSizeInBytes);
	bt_error_t Read(bt_devaddr_t, WORD *, DWORD numOfBytes, DWORD blockSizeInBytes);
	bt_error_t Read(bt_devaddr_t, DWORD *, DWORD numOfBytes, DWORD blockSizeInBytes);

	void SetAMOD(DWORD);
    void Clear(void);
	void Reset(void);
	DWORD GetAMOD(void);
	bt_error_t GetStatus(void);
	void SetDMAThreshold(WORD dmaThreshold);


	bt_error_t SetMemoryMap(bt_devaddr_t, DWORD imageSize);
	void WriteMemMap(DWORD offset, WORD data);  
    void WriteMemMap(DWORD offset, WORD * data, DWORD numOfWords);
	void WriteMemMap(DWORD offset, DWORD* data, DWORD numOfDoubleWords);
    void WriteMemMap(DWORD offset, BYTE* data, DWORD numOfBytes);

	BYTE ReadMemMap(DWORD offset);
	void ReadMemMap(DWORD offset, WORD* data, DWORD numOfBytes);
	void ReadMemMap(DWORD offset, DWORD* data, DWORD numOfDoubleWords);
	void ReadMemMap(DWORD offset, BYTE* data, DWORD numOfBytes);




protected:

	bt_desc_t device;
	bt_error_t error_status;
    bt_width_t dataSize;
	char devName[BT_MAX_DEV_NAME];
	BOOL isMapped;
	DWORD imageMapSize;
	BYTE* lpMemMapBase;

};

#endif
